// ************* MAGIC MENU (RIGHT CLICK) ************************************
	
// This is where right-click menu is defined for left and right subbackground
// First define variables

// Number of options
__EXEC(FCM_menu_elements = 8)
__EXEC(FCM_menu_elements_1 = FCM_menu_elements-1)

// Border size
__EXEC(FCM_menu_border_W = 0.001)
__EXEC(FCM_menu_border_H = FCM_menu_border_W * 1.34)

// Size
__EXEC(FCM_menu_W = 0.18)

// Position
__EXEC(FCM_menu_X = 0.295)
__EXEC(FCM_menu_Y = 0.74)

// Text size
__EXEC(FCM_menu_textH = 0.025)

// Spaces
__EXEC(FCM_menu_edgeW = 0.005)
__EXEC(FCM_menu_edgeH = 0.01)
__EXEC(FCM_menu_textspace = 0.005)

// Shade offset
__EXEC(FCM_menu_shadeX = 0.01)
__EXEC(FCM_menu_shadeY = 0.02)

// Calculate height
__EXEC(FCM_menu_H = FCM_menu_elements * FCM_menu_textH + FCM_menu_elements_1 * FCM_menu_textspace + FCM_menu_edgeH*2)

// Calculate position
__EXEC(FCM_menu_X = FCM_Background_X + FCM_Edge_SpaceW + FCM_SubBackW - FCM_menu_W - FCM_menu_shadeX - 0.005)
__EXEC(FCM_menu_Y = FCM_Background_Y + FCM_Edge_SpaceH + FCM_TopSubHeight + FCM_Sub_SpaceH + FCM_SubBackH - FCM_menu_H - FCM_menu_shadeY - 0.003)

	// Save backgrounds coords to a file
	#ifdef FCM_SAVE_COORDS
		fcm_save6 = __EVAL(loadFile Format[":file write fcm_dialog.db menu %1",[FCM_menu_X, FCM_menu_Y, FCM_menu_W, FCM_menu_H]])
	#endif

// This is a template for the background
/* Consists of:
	- shade behind the background
	- texture background image
	- half transparent blue color background
	- white line for the upper border
	- white line for the left border
	- black line for the right border
	- black line for the bottom boder
*/

#define FCM_menu_background(CLASS, IDC) \
	class CLASS##_Shade : fcmTXT \
	{ \
		idc = IDC; \
		x = __EVAL(FCM_menu_X + FCM_menu_shadeX); \
		y = __EVAL(FCM_menu_Y + FCM_menu_shadeY); \
		w = __EVAL(FCM_menu_W); \
		h = __EVAL(FCM_menu_H); \
		colorBackground[] = {black, 0.4}; \
	}; \
	class CLASS##_BackgroundIMG : CLASS##_Shade \
	{ \
		style = 48; \
		idc = IDC + 1; \
		x = __EVAL(FCM_menu_X); \
		y = __EVAL(FCM_menu_Y); \
		colorText[] = {white, 1}; \
		text = "..\FlashpointCutsceneMaker\paa\menu_background128.paa"; \
	}; \
	class CLASS##_Background : CLASS##_Shade \
	{ \
		idc = IDC + 2; \
		x = __EVAL(FCM_menu_X); \
		y = __EVAL(FCM_menu_Y); \
		colorBackground[] = {royalblue,0.4}; \
	}; \
	class CLASS##_UpperLine : fcmTXT \
	{ \
		idc = IDC + 3; \
		x = __EVAL(FCM_menu_X); \
		y = __EVAL(FCM_menu_Y - FCM_menu_border_W); \
		w = __EVAL(FCM_menu_W); \
		h = __EVAL(FCM_menu_border_W); \
		colorBackground[] = {white, 1}; \
	}; \
	class CLASS##_LeftLine : CLASS##_UpperLine \
	{ \
		idc = IDC + 4; \
		y = __EVAL(FCM_menu_Y); \
		w = __EVAL(FCM_menu_border_W); \
		h = __EVAL(FCM_menu_H); \
	}; \
	class CLASS##_DownLine : fcmTXT \
	{ \
		idc = IDC + 5; \
		x = __EVAL(FCM_menu_X); \
		y = __EVAL(FCM_menu_Y + FCM_menu_H - FCM_menu_border_H); \
		w = __EVAL(FCM_menu_W); \
		h = __EVAL(FCM_menu_border_H); \
		colorBackground[] = {black, 1}; \
	}; \
	class CLASS##_RightLine : fcmTXT \
	{ \
		idc = IDC + 6; \
		x = __EVAL(FCM_menu_X + FCM_menu_W); \
		y = __EVAL(FCM_menu_Y - FCM_menu_border_H); \
		w = __EVAL(FCM_menu_border_W); \
		h = __EVAL(FCM_menu_H + FCM_menu_border_H); \
		colorBackground[] = {black, 1}; \
	}; \

FCM_menu_background(Lmenu, 1000)

// Calculate position for the second menu on the right side
__EXEC(FCM_menu_X = FCM_Background_X + FCM_Edge_SpaceW + FCM_Sub_SpaceW + FCM_SubBackW*2 - FCM_menu_W - FCM_menu_shadeX - 0.005)

	// Save backgrounds coords to a file
	#ifdef FCM_SAVE_COORDS
		fcm_save7 = __EVAL(loadFile Format[":file awrite fcm_dialog.db menu %1",[FCM_menu_X]])
	#endif

FCM_menu_background(Rmenu, 2000)

//--------


// Bring back position for the first menu on the left side
__EXEC(FCM_menu_X = FCM_Background_X + FCM_Edge_SpaceW + FCM_SubBackW - FCM_menu_W - FCM_menu_shadeX - 0.005)

// Define var that is used to place text in the right row
__EXEC(FCM_menu_YPOS = FCM_menu_Y + FCM_menu_edgeH)

// This is a template for a single text button
/* Consists of:
	- white text
	- black text
	- bright blue background
	- black line for the upper border
	- black line for the left border
	- white line for the right border
	- white line for the bottom boder
*/

#define FCM_menu_text(CLASS, IDC, TEXT) \
	class CLASS : fcmTXT \
	{ \
		idc = IDC; \
		x = __EVAL(FCM_menu_X + FCM_menu_edgeW); \
		y = __EVAL(FCM_menu_YPOS); \
		w = __EVAL(FCM_menu_W - FCM_menu_edgeW*2); \
		h = __EVAL(FCM_menu_textH); \
		sizeEx = __EVAL(FCM_menu_textH - 0.005); \
		text = TEXT; \
	}; \
	class CLASS##_Black : CLASS \
	{ \
		idc = IDC + 1; \
		colorText[]={black, 0.75}; \
	}; \
	class CLASS##_Background : CLASS \
	{ \
		idc = IDC + 2; \
		text = ; \
		colorBackground[] = {lightblue2,0.3}; \
	}; \
	class CLASS##_UpperLine : CLASS##_Background \
	{ \
		idc = IDC + 3; \
		colorBackground[] = {black, 1}; \
		h = __EVAL(FCM_menu_border_H); \
	}; \
	class CLASS##_LeftLine : CLASS##_Background \
	{ \
		idc = IDC + 4; \
		colorBackground[] = {black, 1}; \
		w = __EVAL(FCM_menu_border_W); \
		h = __EVAL(FCM_menu_textH); \
	}; \
	class CLASS##_DownLine : CLASS##_Background \
	{ \
		idc = IDC + 5; \
		colorBackground[] = {white, 1}; \
		x = __EVAL(FCM_menu_X + FCM_menu_edgeW + FCM_menu_border_W); \
		y = __EVAL(FCM_menu_YPOS + FCM_menu_textH - FCM_menu_border_H); \
		w = __EVAL(FCM_menu_W - FCM_menu_edgeW*2 - FCM_menu_border_W); \
		h = __EVAL(FCM_menu_border_H); \
	}; \
	class CLASS##_RightLine : CLASS##_Background \
	{ \
		idc = IDC + 6; \
		colorBackground[] = {white, 1}; \
		x = __EVAL(FCM_menu_X + FCM_menu_edgeW + FCM_menu_border_W + FCM_menu_W - FCM_menu_edgeW*2 - FCM_menu_border_W*2); \
		y = __EVAL(FCM_menu_YPOS + FCM_menu_border_H); \
		w = __EVAL(FCM_menu_border_W); \
		h = __EVAL(FCM_menu_textH - FCM_menu_border_H); \
	}; \
	__EXEC(FCM_menu_YPOS = FCM_menu_YPOS + FCM_menu_textH + FCM_menu_textspace);

	
FCM_menu_text(Lmenu_Text1, 1010, Delete)
FCM_menu_text(Lmenu_Text2, 1020, Cut)
FCM_menu_text(Lmenu_Text3, 1030, Copy)
FCM_menu_text(Lmenu_Text4, 1040, Paste)
FCM_menu_text(Lmenu_Text5, 1050, Paste after this)
FCM_menu_text(Lmenu_Text6, 1060, Paste at the end)
FCM_menu_text(Lmenu_Text7, 1070, Add new after this)
FCM_menu_text(Lmenu_Text8, 1080, Add new at the end)
	
// Calculate position for the second menu on the right side
__EXEC(FCM_menu_X = FCM_Background_X + FCM_Edge_SpaceW + FCM_Sub_SpaceW + FCM_SubBackW*2 - FCM_menu_W - FCM_menu_shadeX - 0.005)	
	
// Reset Y variable for the second menu
__EXEC(FCM_menu_YPOS = FCM_menu_Y + FCM_menu_edgeH)	

FCM_menu_text(Rmenu_Text1, 2010, Delete)
FCM_menu_text(Rmenu_Text2, 2020, Cut)
FCM_menu_text(Rmenu_Text3, 2030, Copy)
FCM_menu_text(Rmenu_Text4, 2040, Paste)
FCM_menu_text(Rmenu_Text5, 2050, Paste after this)
FCM_menu_text(Rmenu_Text6, 2060, Paste at the end)
FCM_menu_text(Rmenu_Text7, 2070, Add new after this)
FCM_menu_text(Rmenu_Text8, 2080, Add new at the end)


/*
other colors:
		//colorBackground[] = {0.2039,0.5294,0.5059,0.45};	// medium aquamarine
		//colorBackground[] = {0.5843,0.7255,0.7804,0.65};	// lightblue3
		//colorBackground[] = {0.4000,0.5961,1,0.4};		// skyblue
		//colorBackground[] = {0.2431,0.6627,0.6235,0.4};			// lightseagreen
		//colorBackground[] = {0.6039,0.9961,1,0.4};			// darkslategray
		//colorBackground[] = {0.7608,0.3529,0.4863,0.4};			// palevioletred3
		//colorBackground[] = {0.4784,0.3647,0.7804,0.2};			// mediumpurple3
		colorBackground[] = {0.1686,0.3765,0.8706,0.4};			// royalblue
		//colorBackground[] = {white,0.4};			// white
		//colorBackground[] = {0.658, 0.658, 0.658,0.6};			// workbench white
*/


	// Save backgrounds coords to a file
	#ifdef FCM_SAVE_COORDS
		fcm_save8 = __EVAL(loadFile Format[":file awrite fcm_dialog.db menu %1",[FCM_menu_edgeW, FCM_menu_edgeH, FCM_menu_W - FCM_menu_edgeW*2, FCM_menu_textH, FCM_menu_textspace, FCM_menu_elements]])
	#endif
	
// ************* END OF MAGIC MENU (RIGHT CLICK) ********************************