// ************* SUB-BACKGROUND CONTENTS *************************************	

// Variable used to select line and column
__EXEC(FCM_Col = 0)		// x
__EXEC(FCM_Line = 0)	// y


// Variable used in equation, determines how many spaces already went through
// It equals one because space between first cell and sub-background edge is already added to the base
__EXEC(FCM_SpaceCol = 1)	// x
__EXEC(FCM_SpaceLine = 1)	// y

	
// Starting X,Y position, determines in which sub-background element will be placed
__EXEC(FCM_BaseX = FCM_Background_X + FCM_Edge_SpaceW + FCM_CellEdge_SpaceW)
__EXEC(FCM_BaseY = FCM_Background_Y + FCM_Edge_SpaceH + FCM_TopSubHeight + FCM_Sub_SpaceH + FCM_CellEdge_SpaceH)

__EXEC(FCM_BaseX2 = FCM_Background_X + FCM_Edge_SpaceW + FCM_CellEdge_SpaceW + FCM_Sub_SpaceW + FCM_SubBackW)



// Alias to switch to the next line
#define FCM_NextLine 	__EXEC(FCM_Line=FCM_Line+1; FCM_SpaceLine=FCM_SpaceLine+1)

// Alias to switch to the next column
#define FCM_NextColumn	__EXEC(FCM_BaseX=FCM_BaseX+FCM_CurSel+FCM_CellSub_SpaceW; FCM_BaseX2=FCM_BaseX2+FCM_CurSel+FCM_CellSub_SpaceW; FCM_Col=FCM_Col+1; FCM_Line=0; FCM_SpaceLine=1)


// Control element template
#define FCM_CELL(CLASSNAME, INHERIT, MODIFYX, MODIFYY, MODIFYW, MODIFYH, TEXT, IDC) \
	__EXEC(FCM_CurSel = FCM_Columns select FCM_Col) \
	class CLASSNAME : INHERIT \
	{ \
		x = __EVAL(FCM_BaseX + MODIFYX); \
		y = __EVAL(FCM_BaseY + FCM_LineHeight*FCM_Line + FCM_CellSub_SpaceH*(FCM_SpaceLine-1) + MODIFYY); \
		w = __EVAL(FCM_CurSel + MODIFYW); \
		h = __EVAL(FCM_LineHeight + MODIFYH); \
		text = TEXT; \
		idc = IDC; \
	}; \
	class CLASSNAME##2 : CLASSNAME \
	{ \
		x = __EVAL(FCM_BaseX2 + MODIFYX); \
		idc = IDC+100; \
	};

// Execs have problem with 'select' so that's why there's FCM_CurSel
//		colorBackground[] = {red, 0.5}; \

#define MoveTitleX (FCM_Columns select 0)+FCM_CellSub_SpaceW
#define MoveTitleLength (FCM_Columns select 1)-(FCM_Columns select 0)+FCM_CellSub_SpaceW*2+(FCM_Columns select 2)+(FCM_Columns select 3)
	
// Putting elements in the left sub-background
// From top to bottom
// class; inherit; x,y,w,h change; text; idc
FCM_CELL(Move, 		fcmTXTCOLOR, -0.005,0,0,0, "Move #1", 100) 			
FCM_CELL(MoveTitle, fcmTXTCOLOR, MoveTitleX-0.004,0,MoveTitleLength,0, "", 101)
FCM_CELL(MoveInput, fcmINPUT, MoveTitleX,0,MoveTitleLength,0, "", 102)

	#ifdef FCM_SAVE_COORDS
		fcm_save9 = __EVAL(loadFile Format[":file qwrite fcm_dialog.db moveinput %1",[FCM_BaseX + 0.107-0.02, FCM_BaseY + FCM_LineHeight*FCM_Line + FCM_CellSub_SpaceH*(FCM_SpaceLine-1), FCM_CurSel + MoveTitleLength, FCM_LineHeight,  FCM_BaseX2+0.107-0.02]])
	#endif

FCM_NextLine

FCM_CELL(Target, 	 fcmACTIVE, 0,0,0,0, "Target:", 110)
FCM_CELL(TargetGray, fcmACTIVEGRAY, 0,0,0,0, "Target:", 111)
FCM_CELL(TargetText, fcmTXT,-0.005,0,0,0, "Target:", 112)
FCM_NextLine

FCM_CELL(Position,     fcmACTIVE, 0,0,0,0, "Position:", 120)
FCM_CELL(PositionGray, fcmACTIVEGRAY, 0,0,0,0, "Position:", 121)
FCM_CELL(PositionText, fcmTXT,-0.005,0,0,0, "Position:", 122)
FCM_NextLine

FCM_CELL(FOV,     fcmACTIVE, 0,0,0,0, "FOV:", 130)
FCM_CELL(FOVGray, fcmACTIVEGRAY, 0,0,0,0, "FOV:", 131)
FCM_NextColumn
FCM_NextLine

FCM_CELL(TargetList,   	fcmCombo, 0,0,0,0, "", 113) 
FCM_CELL(TargetNoChange,fcmTXTGRAY, 0,0,0,0, "No change", 114)
FCM_NextLine

FCM_CELL(PositionList, 	fcmCombo, 0,0,0,0, "", 123)
FCM_CELL(PositionNoChange,fcmTXTGRAY, 0,0,0,0, "No change", 124)
FCM_NextLine

FCM_CELL(FOVInput,     	fcmINPUT, 0,0,0,0, "0.7", 133)
FCM_CELL(FOVNoChange,	fcmTXTGRAY, 0,0,0,0, "No change", 134)
FCM_NextColumn
FCM_NextLine

FCM_CELL(Commit,    fcmTXT, 0,0,0,0, "Commit:", 140) 	FCM_NextLine
FCM_CELL(Condition, fcmTXT, 0,0,0,0, "Condition:", 150) FCM_NextLine
FCM_CELL(Wait,      fcmTXT, 0,0,0,0, "Wait:", 160)
FCM_NextColumn
FCM_NextLine

FCM_CELL(CommitInput, fcmINPUT, 0,0,0,0, "4", 141)
FCM_CELL(CommitZero,  fcmTXTSMALL,0,0,0,0, "0", 142)		
FCM_CELL(CommitDUMMY, fcmINPUT, 0,0,0,0, "", 143)		FCM_NextLine
FCM_CELL(ConditList,  fcmCombo, 0,0,0,0, "", 151) 
FCM_CELL(ConditDUMMY, fcmCombo, 0,0,0,0, "", 152) 		FCM_NextLine
FCM_CELL(WaitInput,   fcmINPUT, 0,0,0,0, "0", 161)
FCM_CELL(WaitDUMMY,   fcmINPUT, 0,0,0,0, "0", 162)


// ************* END OF SUB-BACKGROUND CONTENTS ******************************