
/*
Function finds difference between two camera positions in degrees
*/



	// Init vars
private ["_move","_px","_tx","_py","_ty","_pz","_tz","_dist","_dir"];
_move = _this;



	// Get previous position
_data = ["Position",_move] call FCM_SQF_GETDATA;
_prevPos = _data select 0;
_prevPosdata = _data select 1;
_px = _prevPosdata select 0;
_py = _prevPosdata select 1;
_pz = _prevPosdata select 2;

	// Get previous target
_data = ["Target",_move] call FCM_SQF_GETDATA;
_prevTar = _data select 0;
_prevTardata = _data select 1;
if (count FCM_CURRTARDATA == 1) then {_prevTardata=call (_prevTardata select 0)};
_tx = _prevTardata select 0;
_ty = _prevTardata select 1;
_tz = _prevTardata select 2;




	// Angle from previous camera position to previous camera target
_angle1 = (_px - _tx) atan2 (_py - _ty);
if (_angle1 < 0) then {_angle1=_angle1+360};

	// Angle from current camera position to previous camera target
_angle2 = (FCM_x - _tx) atan2 (FCM_y - _ty);
if (_angle2 < 0) then {_angle2=_angle2+360};

	// Calculate difference
_dir = _angle2 - _angle1;




	// Get distance from camera to target
_dist = sqrt ((FCM_x - FCM_Tx)^2 + (FCM_y - FCM_Ty)^2);

	// Calculate new camera position
FCM_x = FCM_Tx + _dist * sin(_dir);
FCM_y = FCM_Ty + _dist * cos(_dir);
[] call FCM_SQF_REL;




	// Update vars and camera
if ((FCM_TYPE select _move) select 1 == 1) then		// if position absolute
{
	FCM_POSITION set [FCM_MOVE, [FCM_x, FCM_y, FCM_z]];
	FCM_CAM camSetPos [FCM_x, FCM_y, FCM_z];
}
else												// else relative
{
	FCM_POSITION set [FCM_MOVE, [FCM_Rx, FCM_Ry, FCM_Rz]];
	FCM_CAM camSetPos [FCM_Rx, FCM_Ry, FCM_Rz];
};
FCM_CAM camCommit 0;	





	// Return direction
_dir