
/*
Function changes FCM_MOVE and FCM_SCROLL values

Input: 
	number - transfer to that move
	array with a number - transfer between that many moves
*/



/* Function calls:
	home : move to 0
	end  : move to max
	play stop   : move to X
	
	prev : -1 scroll
	next : +1 scroll
	delete, cut : -1 move
	paste, add  : +1 move
*/



// Local vars
private ["_move","_dir","_mode"];



// Check what kind of var was passed to the function
if (_this in [_this]) then
{
	// passed integer
	_move = _this;
	
	// Go to the first -----------------------------------------------------------------------------
	if (_move == 0) then {FCM_MOVE=0; FCM_SCROLL=0};
	
	// Go to the last ------------------------------------------------------------------------------
	if (_move == FCM_MOVES-1) then {FCM_MOVE=FCM_MOVES-1; FCM_SCROLL=FCM_MOVES-2};	
	
	// Somewhere in the middle ---------------------------------------------------------------------
	if (!(_move in [0,FCM_MOVES-1,FCM_MOVE])) then
	{
		// Set direction: left (-1) or right (+1)
		_dir = 1;
		if (_move < FCM_MOVE) then {_dir=-1};
		
		// Iterate move var until it reaches the destination
		while "FCM_MOVE != _move" do
		{
			// If it's not going out of bounds
			if (FCM_MOVE+_dir >= 0   &&   FCM_MOVE+_dir <= FCM_MOVES-1) then
			{
				FCM_MOVE = FCM_MOVE + _dir;
			
				// If scroll var is away from visible area then adjust it
				if (FCM_MOVE < FCM_SCROLL   ||   FCM_SCROLL > FCM_MOVES-2) then
				{
					FCM_SCROLL = FCM_SCROLL + _dir;
				};
			}
			else
			{
				// If it's going out of bounds then change _move which stops the loop
				_move = FCM_MOVE;
			};
		};
	};
	
}



else



{
	// passed array
	_dir = _this select 0;
	_mode = _this select 1;
	
	// Change scroll variable and move var only if necessary ---------------------------------------
	if (_mode == "scroll") then
	{
		// Continue only if it's not going out of bounds
		if (FCM_SCROLL+_dir >= 0   &&   FCM_SCROLL+_dir <= FCM_MOVES-2) then
		{
			FCM_SCROLL = FCM_SCROLL + _dir;
			
			// If move var is away from visible area then adjust it
			if (FCM_MOVE!=FCM_SCROLL   &&   FCM_MOVE!=FCM_SCROLL+1) then
			{
				FCM_MOVE = FCM_MOVE + _dir;
			};
		}
		// Reached the edge, check if can adjust move var
		else
		{
			if (_dir<0 && FCM_MOVE>0) then {FCM_MOVE=0};	// to the left edge
			if (_dir>0 && FCM_MOVE<FCM_MOVES-1) then {FCM_MOVE=FCM_MOVES-1};	// to the right edge
		};
	};
	// ---------------------------------------------------------------------------------------------
	
	// Change move variable and scroll var only if necessary ---------------------------------------
	if (_mode == "move") then
	{	
		// Continue only if it's not going out of bounds
		if (FCM_MOVE+_dir >= 0   &&   FCM_MOVE+_dir <= FCM_MOVES-1) then
		{
			FCM_MOVE = FCM_MOVE + _dir;
			
			// If scroll var is away from visible area then adjust it
			if (FCM_MOVE < FCM_SCROLL   ||  FCM_MOVE>FCM_SCROLL+1  ||   FCM_SCROLL>FCM_MOVES-2) then
			{
				FCM_SCROLL = FCM_SCROLL + _dir;
			};
		};
	};
	// ---------------------------------------------------------------------------------------------
};