
/*
Function updates target related dialog controls and camera
*/



	// Input variables:
private ["_move", "_state"];
_move = _this select 0;
_state = _this select 1;


	// Set idc number to left or right sub-background
_idc = 100;
if (_move==FCM_SCROLL+1) then {_idc=200};


	// Current target type
_tar = (FCM_TYPE select _move) select 0;
_data = ["Target",FCM_MOVE] call FCM_SQF_GETDATA;
FCM_CURRTAR = _data select 0;
FCM_CURRTARDATA = _data select 1;




	// ERROR CHECK: if target actor is NOT in actors array
//--------------------------------------------------------------------------------------------------------------------------------------------
if (FCM_CURRTAR == 3) then		// if target is actor type
{
	if (!((FCM_CURRTARDATA select 0) in FCM_ACTORS)) then	// if not in actor's list
	{
		private "_i";
		_i = _move;
		if (_tar<0) then		// if current is 'no change'
		{
			_found = false;
			while "_i>0 && !_found" do		// then search for the source
			{
				if (((FCM_TYPE select _i) select 0)==3) then {_found=true};
				if (!_found) then {_i=_i-1};
			};
		};
				
		// Display message
		Format["Missing actor: %1 in move #%2\nSwitched type to position", (FCM_CURRTARDATA select 0),_i+1] call FCM_SQF_MSG;
		
		// Change vars to target type position
		//_type = FCM_TYPE select _i;
		_type = [(FCM_TYPE select _i) select 0,(FCM_TYPE select _i) select 1,(FCM_TYPE select _i) select 2,(FCM_TYPE select _i) select 3];
//		_type = [(FCM_TYPE select _i) select 0,(FCM_TYPE select _i) select 1,(FCM_TYPE select _i) select 2,(FCM_TYPE select _i) select 3,(FCM_TYPE select _i) select 4];	for rotation
		_type set [0, 1];
		FCM_TYPE set [_i, _type];
		FCM_TARGET set [_i, [FCM_tX,FCM_tY,FCM_tZ]];
		if (_tar>0) then {_tar=1;};
		FCM_CURRTAR = 1;
		FCM_CURRTARDATA = [FCM_tX,FCM_tY,FCM_tZ];
	};
};
//--------------------------------------------------------------------------------------------------------------------------------------------




	// Set two arrays with idc numbers
_all = [_idc+10,_idc+11,_idc+12,_idc+13,_idc+14,300,301,302];
_toShow = [];




	// Inactive - show gray button and "no change"
if (_tar < 0) then {_toShow = _toShow + [_idc+11,_idc+14];};
	
	
	// Active
if (_tar > 0) then
{
	if (_move==0) then 					// if first move then show text instead of a button
	{
		_toShow = _toShow + [_idc+12];
	} else
	{
		_toShow = _toShow + [_idc+10];
	};	
	
	_toShow = _toShow + [_idc+13];		// show drop-down
	lbSetCurSel [_idc+13, _tar-1];		// set drop-down current row
};




	// If this move is currently active one (highlighted sub-background)
if (_move == FCM_MOVE) then
{
		// Commit camera
	if (count FCM_CURRTARDATA != 1) then		
	{
		FCM_CAM camSetTarget FCM_CURRTARDATA;	// for position or nearest object
		FCM_Tx = FCM_CURRTARDATA select 0;
		FCM_Ty = FCM_CURRTARDATA select 1;
		FCM_Tz = FCM_CURRTARDATA select 2;
	} else										
	{
		FCM_CAM camSetTarget (call (FCM_CURRTARDATA select 0));		// for actor
	};
	FCM_CAM camCommit 0;
	

	
		// if "nearest object"
	if (FCM_CURRTAR == 2) then
	{
		_toShow = _toShow + [302];										// show actor name
		_move exec "..\FlashpointCutsceneMaker\NearestTarget.sqs";		// launch search script
	}; 

		// if "actor"
	if (FCM_CURRTAR == 3) then
	{
		_toShow = _toShow + [302];				// show's actor name
		_ActorSTR = FCM_CURRTARDATA select 0;	// actor var name
		_ActorOBJ = call _ActorSTR;				// actor object var
		
		if (_tar > 0) then			// if target is active
		{
			_toShow = _toShow + [300, 301];									// show actors list box
			lbSetCurSel [301, (_actorSTR call FCM_SQF_ACTOR)];				// set listbox current selection
			ctrlSetText [302, "           "+(_ActorOBJ call FCM_SQF_NAME)]	// set actor's name
		}
		else						// if inactive ("no change")
		{
			ctrlSetText [302, _ActorOBJ call FCM_SQF_NAME]					// set actor's name
		};
	};
};

	// If previous move has custom code but this one doesn't then don't hide input
if (_move-1==FCM_MOVE && ctrlVisible 300) then {_toShow=_toShow+[300,301]};
if (_move-1==FCM_MOVE && ctrlVisible 302) then {_toShow=_toShow+[302]};




	// Show elements collected in the array
	"ctrlShow[_x, true]" forEach _toShow;
	
	// Hide those not collected
	"ctrlShow[_x, false]" forEach (_all - _toShow);

	